"use strict";
var __createBinding = (this && this.__createBinding) || (Object.create ? (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    var desc = Object.getOwnPropertyDescriptor(m, k);
    if (!desc || ("get" in desc ? !m.__esModule : desc.writable || desc.configurable)) {
      desc = { enumerable: true, get: function() { return m[k]; } };
    }
    Object.defineProperty(o, k2, desc);
}) : (function(o, m, k, k2) {
    if (k2 === undefined) k2 = k;
    o[k2] = m[k];
}));
var __setModuleDefault = (this && this.__setModuleDefault) || (Object.create ? (function(o, v) {
    Object.defineProperty(o, "default", { enumerable: true, value: v });
}) : function(o, v) {
    o["default"] = v;
});
var __importStar = (this && this.__importStar) || function (mod) {
    if (mod && mod.__esModule) return mod;
    var result = {};
    if (mod != null) for (var k in mod) if (k !== "default" && Object.prototype.hasOwnProperty.call(mod, k)) __createBinding(result, mod, k);
    __setModuleDefault(result, mod);
    return result;
};
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.isPathSymlink = exports.isPathFile = exports.isPathDir = exports.writeFolderOfFiles = exports.updateJsonFile = exports.updateFile = exports.updatePkgJson = exports.getPackageJson = exports.findRootDir = exports.isMonorepoPkg = exports.findGitRoot = exports.findAllParentPkgJsons = exports.assertFileExists = exports.hasFileUp = exports.findUpPkgJsonAsync = exports.findUpPkgJson = exports.getModulePkgJson = exports.ensureDirCached = exports.getPackageJsonSync = exports.writeYamlFormatted = exports.writeYamlSync = exports.writeYaml = exports.readYamlSync = exports.readYaml = exports.stringifyYaml = exports.parseYaml = exports.readFileSync = exports.readFile = exports.readJSONSync = exports.readJSON = exports.writeJSONSync = exports.writeJSON = exports.writeFormattedFileSync = exports.writeFormattedFile = exports.writeFileSync = exports.writeFile = exports.removeSync = exports.remove = exports.moveSync = exports.move = exports.copySync = exports.copy = exports.emptyDir = exports.emptyDirSync = exports.ensureDirSync = exports.ensureDir = exports.exists = exports.existsSync = exports.globby = exports.findUp = void 0;
exports.getMonorepoPkgs = exports.isMonorepo = exports.assertDirExists = void 0;
const fs_extra_1 = __importStar(require("fs-extra"));
const path_1 = require("path");
const os_1 = require("os");
const merge_1 = __importDefault(require("lodash/merge"));
const find_up_1 = __importDefault(require("find-up"));
exports.findUp = find_up_1.default;
const Yaml = __importStar(require("js-yaml"));
const globby_1 = __importDefault(require("globby"));
exports.globby = globby_1.default;
const format_node_1 = require("./format/format-node");
const utils_1 = require("./format/utils");
// we export out common fs-extra functions so usage of our lib has most file system functions. also `fs-extra` does not have it's own types so users have to install `@types/fs-extra` as well
var fs_extra_2 = require("fs-extra");
Object.defineProperty(exports, "existsSync", { enumerable: true, get: function () { return fs_extra_2.existsSync; } });
Object.defineProperty(exports, "exists", { enumerable: true, get: function () { return fs_extra_2.exists; } });
Object.defineProperty(exports, "ensureDir", { enumerable: true, get: function () { return fs_extra_2.ensureDir; } });
Object.defineProperty(exports, "ensureDirSync", { enumerable: true, get: function () { return fs_extra_2.ensureDirSync; } });
Object.defineProperty(exports, "emptyDirSync", { enumerable: true, get: function () { return fs_extra_2.emptyDirSync; } });
Object.defineProperty(exports, "emptyDir", { enumerable: true, get: function () { return fs_extra_2.emptyDir; } });
Object.defineProperty(exports, "copy", { enumerable: true, get: function () { return fs_extra_2.copy; } });
Object.defineProperty(exports, "copySync", { enumerable: true, get: function () { return fs_extra_2.copySync; } });
Object.defineProperty(exports, "move", { enumerable: true, get: function () { return fs_extra_2.move; } });
Object.defineProperty(exports, "moveSync", { enumerable: true, get: function () { return fs_extra_2.moveSync; } });
Object.defineProperty(exports, "remove", { enumerable: true, get: function () { return fs_extra_2.remove; } });
Object.defineProperty(exports, "removeSync", { enumerable: true, get: function () { return fs_extra_2.removeSync; } });
async function writeFile({ path, contents, isBase64, }) {
    await fs_extra_1.default.ensureDir((0, path_1.dirname)(path));
    return fs_extra_1.default.writeFile(path, (0, utils_1.contentsToString)(contents), {
        encoding: isBase64 ? 'base64' : 'utf8',
    });
}
exports.writeFile = writeFile;
function writeFileSync({ path, contents, isBase64, }) {
    fs_extra_1.default.ensureDirSync((0, path_1.dirname)(path));
    return fs_extra_1.default.writeFileSync(path, (0, utils_1.contentsToString)(contents), {
        encoding: isBase64 ? 'base64' : 'utf8',
    });
}
exports.writeFileSync = writeFileSync;
async function writeFormattedFile({ path, contents, }) {
    const fileContents = await (0, format_node_1.formatCode)({ path, contents });
    return writeFile({ path, contents: fileContents });
}
exports.writeFormattedFile = writeFormattedFile;
function writeFormattedFileSync({ path, contents, }) {
    const fileContents = (0, format_node_1.formatCodeSync)({ path, contents });
    return writeFileSync({ path, contents: fileContents });
}
exports.writeFormattedFileSync = writeFormattedFileSync;
/**
 * @see {writeFormattedFile} if you want Prettier formatting
 */
exports.writeJSON = writeFile;
/**
 * @see {writeFormattedFileSync} if you want Prettier formatting
 */
exports.writeJSONSync = writeFileSync;
function readJSON(path, options) {
    const opt = options || { encoding: 'utf8' };
    return (0, fs_extra_1.readJSON)(path, opt);
}
exports.readJSON = readJSON;
function readJSONSync(path, options) {
    const opt = options || { encoding: 'utf8' };
    return (0, fs_extra_1.readJSONSync)(path, opt);
}
exports.readJSONSync = readJSONSync;
function readFile(path) {
    return (0, fs_extra_1.readFile)(path, {
        encoding: 'utf8',
    });
}
exports.readFile = readFile;
function readFileSync(path) {
    return (0, fs_extra_1.readFileSync)(path, {
        encoding: 'utf8',
    });
}
exports.readFileSync = readFileSync;
function parseYaml(yaml) {
    return Yaml.load(yaml);
}
exports.parseYaml = parseYaml;
function stringifyYaml(yaml, options) {
    return Yaml.dump(yaml, {
        lineWidth: 120,
        quotingType: (options === null || options === void 0 ? void 0 : options.doubleQuote) ? '"' : "'",
    });
}
exports.stringifyYaml = stringifyYaml;
async function readYaml(path) {
    const str = await readFile(path);
    return parseYaml(str);
}
exports.readYaml = readYaml;
function readYamlSync(path) {
    return parseYaml(readFileSync(path));
}
exports.readYamlSync = readYamlSync;
async function writeYaml({ path, contents, }) {
    const fileContents = stringifyYaml(contents);
    return writeFile({ path, contents: fileContents });
}
exports.writeYaml = writeYaml;
function writeYamlSync({ path, contents, }) {
    const fileContents = stringifyYaml(contents);
    return writeFileSync({ path, contents: fileContents });
}
exports.writeYamlSync = writeYamlSync;
async function writeYamlFormatted({ path, contents, }) {
    const fileContents = stringifyYaml(contents);
    return writeFormattedFile({ path, contents: fileContents });
}
exports.writeYamlFormatted = writeYamlFormatted;
/** Type-safe package.json reader */
function getPackageJsonSync(pkgPath) {
    return readJSONSync(pkgPath.endsWith('package.json') ? pkgPath : (0, path_1.join)(pkgPath, 'package.json'));
}
exports.getPackageJsonSync = getPackageJsonSync;
const ensuredDirs = new Set();
/**
 * Ensures a directory exists. If it does not exist, it will be created.
 * If it's been ensured before, it will be skipped.
 * Use `ensureDir` if there's a chance it was ensured and then deleted
 */
async function ensureDirCached(dir) {
    if (ensuredDirs.has(dir))
        return;
    await (0, fs_extra_1.ensureDir)(dir);
    ensuredDirs.add(dir);
}
exports.ensureDirCached = ensureDirCached;
/** Type-safe package.json reader */
function getModulePkgJson(moduleName) {
    const { moduleName: name, resolveFrom = process.cwd() } = typeof moduleName === 'string' ? { moduleName } : moduleName;
    try {
        const pkgPath = require.resolve((0, path_1.join)(name, './package.json'), {
            paths: [resolveFrom],
        });
        return getPackageJsonSync(pkgPath);
    }
    catch (error) {
        throw new Error(`Could not find package.json for module: ${name}. Is it installed?`);
    }
}
exports.getModulePkgJson = getModulePkgJson;
function findUpPkgJson(
/**
 * Directory to start looking from.
 * Usually `__dirname` or `process.cwd()`
 * Ok for path to end in `package.json`
 */
dir) {
    const pkgPath = find_up_1.default.sync('package.json', {
        cwd: dir.endsWith('package.json') ? (0, path_1.dirname)(dir) : dir,
    });
    if (!pkgPath) {
        return {
            exists: false,
            pkgPath: '',
            pkgDir: '',
            pkg: {},
        };
    }
    const pkg = readJSONSync(pkgPath);
    return {
        pkgPath,
        pkgDir: (0, path_1.dirname)(pkgPath),
        pkg,
        exists: true,
    };
}
exports.findUpPkgJson = findUpPkgJson;
async function findUpPkgJsonAsync(
/**
 * Directory to start looking from.
 * Usually `__dirname` or `process.cwd()`
 * Ok for path to end in `package.json`
 */
dir) {
    const pkgPath = await (0, find_up_1.default)('package.json', {
        cwd: dir.endsWith('package.json') ? (0, path_1.dirname)(dir) : dir,
    });
    if (!pkgPath) {
        return {
            exists: false,
            pkgPath: '',
            pkgDir: '',
            pkg: {},
        };
    }
    const pkg = await readJSON(pkgPath);
    return {
        pkgPath,
        pkgDir: (0, path_1.dirname)(pkgPath),
        pkg,
        exists: true,
    };
}
exports.findUpPkgJsonAsync = findUpPkgJsonAsync;
function hasFileUp({ file, cwd = process.cwd(), }) {
    return !!find_up_1.default.sync(file, {
        cwd,
    });
}
exports.hasFileUp = hasFileUp;
function assertFileExists(filePath, errorMsg) {
    if (!(0, fs_extra_1.existsSync)(filePath)) {
        throw new Error(errorMsg || `File path does not exist: "${filePath}"`);
    }
}
exports.assertFileExists = assertFileExists;
function findAllParentPkgJsons(dir) {
    assertFileExists(dir);
    const results = [];
    const nearestPkg = find_up_1.default.sync('package.json', {
        cwd: dir,
    });
    if (!nearestPkg)
        return results;
    results.push({
        pkgPath: nearestPkg,
        dir: (0, path_1.dirname)(nearestPkg),
    });
    let nextDir = (0, path_1.dirname)((0, path_1.dirname)(nearestPkg));
    while (nextDir) {
        const nextPkg = find_up_1.default.sync('package.json', {
            cwd: nextDir,
        });
        if (nextPkg) {
            results.push({
                pkgPath: nextPkg,
                dir: (0, path_1.dirname)(nextPkg),
            });
            nextDir = (0, path_1.dirname)((0, path_1.dirname)(nextPkg));
        }
        else {
            nextDir = '';
        }
    }
    return results;
}
exports.findAllParentPkgJsons = findAllParentPkgJsons;
function findGitRoot(dir = process.cwd()) {
    const gitDir = find_up_1.default.sync('.git', {
        cwd: dir,
        type: 'directory',
    });
    if (!gitDir) {
        return '';
    }
    return (0, path_1.dirname)(gitDir);
}
exports.findGitRoot = findGitRoot;
/**
 * If a package.json is found in a directory that is NOT the git root, then this returns true
 */
function isMonorepoPkg(dir = process.cwd()) {
    const gitRoot = findGitRoot(dir);
    const [closestPkg] = findAllParentPkgJsons(dir);
    if (!closestPkg) {
        throw new Error(`No "package.json" files found when searching up from "${dir}"`);
    }
    return closestPkg.dir !== gitRoot;
}
exports.isMonorepoPkg = isMonorepoPkg;
/**
 * Attempts to find the "root" directory (not `/`). Looks in this order:
 * 1) Git repo root
 * 2) A package.json that is highest up in directories
 * 3) The directory parameter passed into this function, which defaults to the CWD
 */
function findRootDir(dir = process.cwd()) {
    try {
        return findGitRoot(dir);
    }
    catch (error) {
        const highestPkg = findAllParentPkgJsons(dir).pop();
        if (!highestPkg) {
            return dir;
        }
        return highestPkg.dir;
    }
}
exports.findRootDir = findRootDir;
/** Type-safe package.json reader */
function getPackageJson(pkgPath) {
    return readJSON(pkgPath.endsWith('package.json') ? pkgPath : (0, path_1.join)(pkgPath, 'package.json'));
}
exports.getPackageJson = getPackageJson;
async function updatePkgJson({ pkg, dir, throwErrorIfAbsent = false, }) {
    var _a, _b;
    const pkgPath = dir.endsWith('package.json')
        ? dir
        : (0, path_1.join)(dir, 'package.json');
    const exists = (0, fs_extra_1.existsSync)(pkgPath);
    if (!exists && throwErrorIfAbsent) {
        throw new Error(`Could not find "package.json" at: "${pkgPath}"`);
    }
    [(_a = pkg.dependencies) !== null && _a !== void 0 ? _a : {}, (_b = pkg.devDependencies) !== null && _b !== void 0 ? _b : {}].forEach((deps) => {
        Object.entries(deps).forEach(([name, version]) => {
            if (!version) {
                throw new Error(`Trying to add dependencies "${name}" to package.json but it has no version declared`);
            }
            // @todo versions like this do not work due to `^`: `^3.15.3--canary.5dc3279.0`
        });
    });
    const previousPkg = exists ? await readJSON(pkgPath) : {};
    const newPkg = (0, merge_1.default)(previousPkg, pkg);
    await writeFormattedFile({
        path: pkgPath,
        contents: JSON.stringify(newPkg, null, '  '),
    });
    return {
        pkg: newPkg,
        isNew: !exists,
        previousPkg,
    };
}
exports.updatePkgJson = updatePkgJson;
async function updateFile({ filePath, alterFile, }) {
    const contents = await readFile(filePath);
    const newContents = await alterFile(contents);
    await writeFormattedFile({
        path: filePath,
        contents: newContents,
    });
}
exports.updateFile = updateFile;
async function updateJsonFile({ filePath, alterFile, }) {
    if (!filePath.endsWith('.json')) {
        throw new Error(`This function is just for working with JSON files, you tried "${filePath}"`);
    }
    const fileString = await readFile(filePath);
    const contents = JSON.parse(fileString);
    const newContents = await alterFile(contents);
    await writeFormattedFile({
        path: filePath,
        contents: newContents,
    });
}
exports.updateJsonFile = updateJsonFile;
/**
 * Use a nested object to write a folder of files easily
 * @example
 * writeFolderOfFiles({
 *   dir: process.cwd(),
 *   handlePriorFile: 'skip',
 *   files: {
 *     'readme.md': '# Welcome!',
 *     'file-to-skip.txt': false,
 *     src: {
 *       'index.ts': 'export const hi = "hello";',
 *       'bigger-file.ts': ['first line', 'second line'],
 *     },
 *   },
 * })
 */
async function writeFolderOfFiles({ dir = process.cwd(), files, handlePriorFile, }) {
    await (0, fs_extra_1.ensureDir)(dir);
    await Promise.all(Object.entries(files).map(async ([path, item]) => {
        const dest = (0, path_1.join)(dir, path);
        if (item === false)
            return;
        const theItem = Array.isArray(item) ? item.join(os_1.EOL) : item;
        if (typeof theItem === 'string') {
            if ((0, fs_extra_1.existsSync)(dest)) {
                switch (handlePriorFile) {
                    case 'skip':
                        return;
                    case 'throwError':
                        throw new Error(`File already exists: "${dest}"`);
                    case 'overwrite':
                        break;
                }
            }
            await writeFormattedFile({
                path: dest,
                contents: theItem,
            });
        }
        else {
            await writeFolderOfFiles({
                dir: dest,
                files: theItem,
                handlePriorFile,
            });
        }
    }));
}
exports.writeFolderOfFiles = writeFolderOfFiles;
function isPathDir(path) {
    try {
        return (0, fs_extra_1.statSync)(path).isDirectory();
    }
    catch (err) {
        return false;
    }
}
exports.isPathDir = isPathDir;
function isPathFile(path) {
    try {
        return (0, fs_extra_1.statSync)(path).isFile();
    }
    catch (err) {
        return false;
    }
}
exports.isPathFile = isPathFile;
function isPathSymlink(path) {
    try {
        return (0, fs_extra_1.statSync)(path).isSymbolicLink();
    }
    catch (err) {
        return false;
    }
}
exports.isPathSymlink = isPathSymlink;
function assertDirExists(dir) {
    if (!(0, fs_extra_1.existsSync)(dir)) {
        throw new Error(`Directory does not exist: "${dir}"`);
    }
    if (!isPathDir(dir)) {
        throw new Error(`Path is not a directory: "${dir}"`);
    }
}
exports.assertDirExists = assertDirExists;
function getMonorepoPkgPaths() {
    const repoRoot = findGitRoot();
    const deglob = (pkgs) => globby_1.default
        .sync(pkgs.map((item) => (0, path_1.join)(item, 'package.json')), {
        cwd: repoRoot,
        absolute: true,
        ignore: ['**/node_modules'],
    })
        .map(path_1.dirname);
    if ((0, fs_extra_1.existsSync)((0, path_1.join)(repoRoot, 'pnpm-workspace.yaml'))) {
        const yaml = readYamlSync((0, path_1.join)(repoRoot, 'pnpm-workspace.yaml'));
        const pkgDirs = deglob(yaml.packages);
        return {
            type: 'pnpm',
            root: repoRoot,
            pkgDirs,
        };
    }
    if ((0, fs_extra_1.existsSync)((0, path_1.join)(repoRoot, 'package.json'))) {
        const pkgJson = getPackageJsonSync(repoRoot);
        if (Array.isArray(pkgJson.workspaces)) {
            const pkgDirs = deglob(pkgJson.workspaces);
            return {
                type: (0, fs_extra_1.existsSync)((0, path_1.join)(repoRoot, 'yarn.lock')) ? 'yarn' : 'npm',
                root: repoRoot,
                pkgDirs,
            };
        }
    }
    // @todo other monorepo types
    throw new Error(`Could not find monorepo root`);
}
function isMonorepo() {
    try {
        getMonorepoPkgPaths();
        return true;
    }
    catch (error) {
        return false;
    }
}
exports.isMonorepo = isMonorepo;
function getMonorepoPkgs() {
    const { pkgDirs, root, type } = getMonorepoPkgPaths();
    const pkgs = pkgDirs.map((pkgDir) => {
        const pkgJson = getPackageJsonSync(pkgDir);
        return {
            pkgJson,
            dir: pkgDir,
        };
    });
    return { pkgs, root, type };
}
exports.getMonorepoPkgs = getMonorepoPkgs;
//# sourceMappingURL=file-utils.js.map