export declare function getJsExportNames({ path, define, alias, resolveFromDir, }: {
    path: string;
    /**
     * Define global variables that can be referenced in the code as if they were defined globally.
     * Passed directly to esbuild's `define` option: https://esbuild.github.io/api/#define
     */
    define?: Record<string, string>;
    /**
     * Alias imports to different paths.
     * Passed directly to esbuild's `alias` option: https://esbuild.github.io/api/#alias
     */
    alias?: Record<string, string>;
    resolveFromDir?: string;
}): Promise<{
    exports: string[];
    /**
     * this function does not throw upon error, `exports` will always be an array
     * if there was a problem, the error message will be here
     */
    errorMsg?: string;
}>;
//# sourceMappingURL=get-js-exports.d.ts.map