"use strict";
var __importDefault = (this && this.__importDefault) || function (mod) {
    return (mod && mod.__esModule) ? mod : { "default": mod };
};
Object.defineProperty(exports, "__esModule", { value: true });
exports.getPackageManager = void 0;
const find_up_1 = __importDefault(require("find-up"));
const path_1 = require("path");
function getPackageManager({ directory } = {}) {
    const cwd = directory || process.cwd();
    const lockFile = find_up_1.default.sync(['yarn.lock', 'pnpm-lock.yaml', 'package-lock.json'], {
        cwd,
    });
    if (!lockFile) {
        return;
    }
    switch ((0, path_1.basename)(lockFile)) {
        case 'yarn.lock':
            return 'yarn';
        case 'pnpm-lock.yaml':
            return 'pnpm';
        case 'package-lock.json':
            return 'npm';
    }
}
exports.getPackageManager = getPackageManager;
//# sourceMappingURL=pkg-utils.js.map