import { PackageJson } from './file-utils';
export declare function getPathType(path: string): {
    type: 'absolute';
} | {
    type: 'relative';
} | {
    type: 'package';
} | {
    type: 'package-sub-path';
    pkgName: string;
    subPath: string;
};
export declare function convertJsExtensionToDts(jsExt: string): string;
type ResolveType = 'mjs' | 'cjs' | 'types';
export declare function resolvePkgExport({ pkg, resolveType, subPath, }: {
    pkg: PackageJson;
    subPath?: string;
    resolveType: ResolveType;
}): string | undefined;
type ResolvePathResults = {
    exists: boolean;
    absolutePath: string;
    originalPath: string;
    type: 'absolute' | 'relative' | 'package' | 'unknown';
};
type ResolvePathOpts = {
    path: string;
    resolveFromDir?: string;
    resolveType?: ResolveType;
    noCjsFallback?: boolean;
};
declare function resolvePathSyncUncached({ path, resolveFromDir, resolveType, noCjsFallback, }: ResolvePathOpts): ResolvePathResults;
/**
 * @deprecated use `resolvePath` instead since it's async
 */
export declare function resolvePathSync(args: Parameters<typeof resolvePathSyncUncached>[0]): ResolvePathResults;
export declare function resolvePath(args: ResolvePathOpts): Promise<ResolvePathResults>;
export {};
//# sourceMappingURL=resolve.d.ts.map